Bug 1290778 - GtkButton/GtkLabel - gtk_style_context_add_provider() fails after gtk_style_context_get_color()
GtkButton/GtkLabel - gtk_style_context_add_provider() fails after gtk_style_c...
Status: CLOSED EOL
Product: Fedora
Classification: Fedora
Component: gtk3 (Show other bugs)
23
Unspecified Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: Matthias Clasen
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2015-12-11 07:33 EST by Martin Stransky
Modified: 2016-12-20 11:55 EST (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2016-12-20 11:55:19 EST
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
testcase (2.26 KB, text/plain)
2015-12-11 07:33 EST, Martin Stransky
no flags Details
testcase - GtkLabel theme (2.75 KB, text/x-csrc)
2015-12-18 04:47 EST, Martin Stransky
no flags Details

  None (edit)
Description Martin Stransky 2015-12-11 07:33:50 EST
Created attachment 1104640 [details]
testcase

Description of problem:

When implementing https://bugzilla.mozilla.org/show_bug.cgi?id=1158076 I found a problem when two themes (default and light) are used in the same application.

See the attached example - when style context is saved gtk_style_context_add_provider() fails to add a CSS provider (or at least I've got a wrong colors).

It seems to affect only GtkButton/GtkLabel

Version-Release number of selected component (if applicable):
gtk3-3.16.7
Comment 1 Matthias Clasen 2015-12-17 15:31:45 EST
I think the gtk version number is wrong ? f23 should have 3.18.x
Comment 2 Benjamin Otte 2015-12-17 15:39:52 EST
That's entirely possible. I certainly wouldn't expect anything this complex to happen between a save()/restore() pair, which are supposed to happen temporarily during draw() or get_size() callbacks.

That said, it might be that this just started working since CSS nodes were introduced in 3.18.
Comment 3 Matthias Clasen 2015-12-17 19:40:36 EST
ftr, CSS nodes were introduced in 3.19.3, so it might have started working in rawhide.
Comment 4 Martin Stransky 2015-12-18 04:47 EST
Created attachment 1107056 [details]
testcase - GtkLabel theme

There's more real-life example.

gtk_style_context_get_color() seems to lock the GtkLabel widget and gtk_style_context_add_provider() is not effective then.

I get text color from GtkLabel and then set light theme and do that again. It works for all widgets but fails for GtkLabel only.
Comment 5 Martin Stransky 2015-12-18 04:49:08 EST
Thanks. The context save()/restore() is not so important here, I'm more focused to the style lock.
Comment 6 Fedora End Of Life 2016-11-24 09:09:46 EST
This message is a reminder that Fedora 23 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 23. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as EOL if it remains open with a Fedora  'version'
of '23'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 23 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 7 Fedora End Of Life 2016-12-20 11:55:19 EST
Fedora 23 changed to end-of-life (EOL) status on 2016-12-20. Fedora 23 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.